package assignment1AADS;

public class MyIntegerBST implements A1Tree {
	
	Node root = null;
	
	@Override
	public void insert(Integer value) {
		if (root == null) {
			root = new Node(value);
		} else {
			root.insert(value);
		}
	}

	@Override
	public Integer mostSimilarValue(Integer value) {
		// not the best since i do the calc for root two times
		// but EH. its all O(1) anyway ;)
		Node suspect = root;
		int bestDiff = Math.abs(value-suspect.value);
		Integer bestValue = suspect.value;
		
		// while(true) looks obnoxious but we go 1 level deeper per iteration,
		// so this has max D iterations where D is depth of tree.
		while (true) {
			// check if this one is better than what we have saved
			if (Math.abs(value-suspect.value) < bestDiff) {
				bestDiff = Math.abs(value-suspect.value);
				bestValue = suspect.value;
			}
			
			// check if we have options for where we can look for a better result.
			// since this is a BST we will always only be interested in one of two possible subtrees,
			// since one of them is guaranteed to only contain worse results.
			if (value < suspect.value) {
				
				// traverse left tree if we can
				if (suspect.left != null) {
					suspect = suspect.left;
					continue;
				} else {
					break; // if we cant, this is as good as it gets
				}
				
			} else if (value > suspect.value) {
				
				// same with right tree
				if (suspect.right != null) {
					suspect = suspect.right;
					continue;
				} else {
					break;
				}
				
			} else {
				// if we are here, we found our exact guy
				bestValue = suspect.value;
				break;
			}
		}
		
		return bestValue;
	}

	@Override
	public void printByLevels() {
		MyQueue<Node> q = new MyQueue<>(); // had to implement a queue here because the built in is illegal
		q.enqueue(root);
		// totally freebasing here. i get the principle bc we talked about it in the lectures,
		// but how do i know when a level is done? can't check queue size because its full of
		// new nodes, supposedly.
		int newsteps = 1;
		int level = 0;
		
		// this loop will run per "level" 
		while (q.size() > 0) {
			int steps = newsteps;
			newsteps = 0;
			int i = 0;
			System.out.print("Depth " + level + ": ");
			
			// this loop will run per node in that level 
			while(i < steps) {
				Node n = q.dequeue();
				System.out.print(n.value + " ");
				
				// add eventual children
				if (n.left != null) {
					q.enqueue(n.left);
					newsteps += 1;
				}
				if (n.right != null) {
					q.enqueue(n.right);
					newsteps += 1;
				}
				i += 1;
			}
			System.out.print("\n");
			level += 1;
		}
		
		
	}
	
	// standard node
	private class Node {
		private Integer value;
		private Node left = null;
		private Node right = null;
		public Node (Integer value) {
			this.value = value;
		}
		
		public void insert (Integer incoming) {
			if (incoming > this.value) {
				if (this.right == null) {
					this.right = new Node(incoming);
				} else {
					this.right.insert(incoming);
				}
			} else  if (incoming < this.value) {
				if (this.left == null) {
					this.left = new Node(incoming);
				} else {
					this.left.insert(incoming);
				}
			}
		}
		
		@Override
		public String toString() {
			StringBuilder builder = new StringBuilder("(");
			if (this.left != null)
				builder.append(" ").append(this.left.toString());
			builder.append(" ").append(this.value).append(" ");
			if (this.right != null)
				builder.append(this.right.toString()).append(" ");
			return builder.append(")").toString();
		}
	}
	
	@Override
	public String toString() {
		if (root != null)
			return root.toString();
		return "[]";
	}

}
