package assignment1AADS;

import java.util.NoSuchElementException;

// making a linked queue bc it has lower complexity, supposedly (no need to resize or shuffle elements).

public class MyQueue<T> {
	
	private class Node {
		T value;
		// O(1)
		public Node(T value) {
			this.value = value;
		}
		
		Node next = null;
	}
	
	private Node first = null;
	private Node last = null;
	
	private int size = 0;
	
	public int size() {
		return this.size;
	}
	
	// O(1)
	public void enqueue(T value) {
		if (this.size == 0) {
			this.first = new Node(value);
			this.last = this.first;
		} else {
			this.last.next = new Node(value);
			this.last = this.last.next;
		}
		this.size += 1;
	}
	
	// O(1)
	public T dequeue() {
		if (this.size < 1) throw new NoSuchElementException();
		T outgoing = this.first.value;
		if (this.first == this.last) {
			this.last = null;
		}
		this.first = this.first.next; // should work even if its the last node? since in that case, this.first.next == null
		this.size -= 1;
		return outgoing;
	}
	
}
