package assignment1AADS;

import java.util.NoSuchElementException;

public class SequenceWithMinimum implements A1SequenceWithMinimum {
	
	private Node leftmost;
	private Node rightmost;

	public SequenceWithMinimum() {
		this.leftmost = null;
		this.rightmost = null;
	}

	@Override
	public void insertRight(Integer value) {
		if (this.rightmost == null) { // then also leftmost is null
			this.leftmost = new Node(value);
			this.rightmost = this.leftmost;
		} else {
			this.rightmost.right = new Node(value);
			this.rightmost.right.left = this.rightmost;
			this.rightmost = this.rightmost.right;
		}
		
	}

	@Override
	public Integer removeRight() {
		if (this.rightmost == null) throw new NoSuchElementException();
		Integer returnValue = this.rightmost.value;
		if (this.rightmost == this.leftmost) {
			this.leftmost = null;
			this.rightmost = null;
		} else {
			this.rightmost.left.right = null;
			this.rightmost = this.rightmost.left;
		}
		return returnValue;
	}

	@Override
	public void insertLeft(Integer value) {
		if (this.leftmost == null) { // then also rightmost is null
			this.leftmost = new Node(value);
			this.rightmost = this.leftmost;
		} else {
			this.leftmost.left = new Node(value);
			this.leftmost.left.right = this.leftmost;
			this.leftmost = this.leftmost.left;
		}
	}

	@Override
	public Integer removeLeft() {
		if (this.leftmost == null) throw new NoSuchElementException();
		Integer returnValue = this.leftmost.value;
		if (this.leftmost == this.rightmost) {
			this.leftmost = null;
			this.rightmost = null;
		} else {
			this.leftmost.right.left = null;
			this.leftmost = this.leftmost.right;
		}
		return returnValue;
	}

	@Override
	public Integer findMinimum() {
		Node current = this.leftmost;
		Integer min = current.value;
		
		if (current.right == null) return min;
		current = current.right;

		while(current != null) {
			if (current.value < min) min = current.value;
			current = current.right;
		}
		return min;
	}
	
	private class Node {
		public Node (Integer v) {
			this.value = v;
		}
		Integer value;
		Node left;
		Node right;
		@Override
		public String toString() {
			return "(" + this.value + ")";
		}
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("(");
		Node n = this.leftmost;
		if (n == null) return sb.append(") lm:").append(this.leftmost).append(" rm:").append(this.rightmost).toString();
		while(n != null) {
			sb.append(n.value);
			if (n.right != null) sb.append(", ");
			n = n.right;
		}
		return sb.append(") lm:").append(this.leftmost).append(" rm:").append(this.rightmost).toString();
	}

}
