package assignment2;

import java.util.Arrays;

public class IntMergeSorter {
	
	public static int[] mergeSort(int[] input) {
		int[] toSort = new int[input.length];
		for (int i = 0; i < toSort.length; i++) {
			toSort[i] = input[i];
		}
		split(toSort,0,toSort.length);

		return toSort;
	}
	
	private static void split(int[] toSort, int start, int end) {
		if(end - start < 2) {
			return;
		}
		int middle = ((end - start)/2)+start;
		split(toSort, start, middle);
		split(toSort, middle, end);
		merge(toSort, start, middle, end);
	}
	
	public static void merge(int[] toSort, int start, int middle, int end) {
		int[] left = new int[middle-start];
		int[] right = new int[end-middle];
		
		for (int place = start, i= 0; place < middle; place++,i++) {
			left[i] = toSort[place];
		}
		for (int place = middle, i= 0; place < end; place++,i++) {
			right[i] = toSort[place];
		}

		
		
		int lpos = 0;
		int rpos = 0;
		int pos = start;
		while (lpos < left.length && rpos < right.length) {
			if (left[lpos] < right[rpos]) {
				// left is smaller
				toSort[pos] = left[lpos];
				lpos+= 1;
			} else {
				// right
				toSort[pos] = right[rpos];
				rpos+= 1;
			}
			pos+= 1;
		}
		for (;lpos < left.length;lpos++,pos+=1) {
			toSort[pos] = left[lpos];
		}
		for (;rpos < right.length;rpos++,pos+=1) {
			toSort[pos] = right[rpos];
		}

	}
	
	public static void printRange(int[] arr, int i1, int i2){
		System.out.println(Arrays.toString(Arrays.copyOfRange(arr, i1, i2)));
	}
	
}


