package assignment2;

import java.util.Arrays;

public class MyItinerary implements A2Itinerary<A2Direction> {
	private A2Direction[] itineraryArr;
	private Integer width;
	private Integer height;
	
	public MyItinerary( A2Direction[] itineraryArr ) {
		this.itineraryArr = itineraryArr;
	}
	@Override
	public A2Direction[] rotateRight() {
		A2Direction[] rotatedItinerary = new A2Direction[itineraryArr.length];
		for(int i = 0;i < itineraryArr.length;i++) {
			rotatedItinerary[i] = rotateOne(itineraryArr[i]);
		}
		return rotatedItinerary;
	}
	
	private A2Direction rotateOne(A2Direction dir) {
		switch(dir) {
			case LEFT:
				return A2Direction.UP;
			case UP:
				return A2Direction.RIGHT;
			case RIGHT:
				return A2Direction.DOWN;
			case DOWN:
				return A2Direction.LEFT;
			default:
				throw new RuntimeException("Aint happenin");
		}
	}

	@Override
	public int widthOfItinerary() {
		if(width == null)
			calcWH();
		return width;
	}
	@Override
	public int heightOfItinerary() {
		if(height == null)
			calcWH();
		
		return height;
	}
	@Override
	public int[] getIntersections() {
		MyHashTable<Point> visitedPoints = new MyHashTable<>(0.5);
		
		Point currentPoint = new Point(0,0);
		int[] stepsWhereRevisiting = new int[itineraryArr.length];
		int numRevisited = 0;
		for(int i = 0;i < itineraryArr.length;i++) {
			currentPoint = currentPoint.move(itineraryArr[i]);
			if(visitedPoints.contains(currentPoint)) {
				stepsWhereRevisiting[numRevisited++] = i;
			} else {
				visitedPoints.insert(currentPoint);
			}
		}
		
		int[] returnArray = new int[numRevisited];
		for (int i = 0; i < numRevisited; i++) returnArray[i] = stepsWhereRevisiting[i];
		
		return returnArray;
	}

	
	private void calcWH() {
		int maxX = 0,
			minX = 0,
			maxY = 0,
			minY = 0;
		
		int posX = 0,
			posY = 0;
		
		for(A2Direction dir : itineraryArr) {
			switch(dir) {
				case LEFT:
					posX--;
					break;
				case UP:
					posY++;
					break;
				case RIGHT:
					posX++;
					break;
				case DOWN:
					posY--;
					break;
				default:
					throw new RuntimeException("Aint happenin");
					
			}
			maxX = Math.max(maxX, posX);
			minX = Math.min(minX, posX);
			maxY = Math.max(maxY, posY);
			minY = Math.min(minY, posY);
		}
		
		width = maxX - minX;
		height = maxY - minY;
	}
	
	private class Point {
		int x;
		int y;
		public Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
		public int hashCode() {
			return (Integer.toString(x) + "," + Integer.toString(y)).hashCode();
		}
		public boolean equals(Object b) {
			if(b instanceof Point) {
				Point bb = ((Point) b);
				return (bb.x == x && bb.y == y);
			}else
				return false;
		}
		public Point move(A2Direction dir) {
			switch(dir) {
				case LEFT:
					return new Point(x-1,y);
				case UP:
					return new Point(x,y+1);
				case RIGHT:
					return new Point(x+1,y);
				case DOWN:
					return new Point(x,y-1);
				default:
					throw new RuntimeException("Aint happenin");
			}
		}
		public String toString() {
			return "(" + x + "," + y + ")";
		}
	}
    
}
