package assignment2;

public class MyMeasure implements A2Measure {

	@Override
	public boolean isSameCollection(int[] array1, int[] array2) {
		if (array1.length != array2.length) return false; 
		CollectionComparationTable<Integer> table = new CollectionComparationTable<>(0.5);
		for (Integer x: array1) {
			table.insert(x);
		}
		for (Integer x: array2) {
			table.delete(x);
		}
		return table.size() == 0;
	}

	@Override
	public int minDifferences(int[] array1, int[] array2) {
		int[] a1sorted = IntMergeSorter.mergeSort(array1);
		int[] a2sorted = IntMergeSorter.mergeSort(array2);
		int sumcollector = 0;
		for (int i = 0; i < a1sorted.length; i++) {
			sumcollector += (a1sorted[i]-a2sorted[i])*(a1sorted[i]-a2sorted[i]);
		}
		return sumcollector;
	}

	@Override
	public int[] getPercentileRange(int[] arr, int lower, int upper) {
		// sort incoming array
		int[] sortedArr = IntMergeSorter.mergeSort(arr);
		
		// get indices
		int lowPercentileIndex = (int) ((lower/100.0)*sortedArr.length);
		int highPercentileIndex = (int) ((upper/100.0)*sortedArr.length);
		
		// copy to new array
		int[] rangeArr = new int[highPercentileIndex-lowPercentileIndex];
		for (int i = 0; i < rangeArr.length; i++) {
			rangeArr[i] = sortedArr[lowPercentileIndex + i];
		}
		
		return rangeArr;
	}

}
