package assignment2;

import java.util.Arrays;

public class PercentilePartition {
	private int[] partArr;
	private int lowPercentileIndex;
	private int highPercentileIndex;
	
	public static void main(String[] arr) {
		new PercentilePartition(new int[] {20,16,2,4,10,6,12,8,14,18}, 10, 50); //obs
	}
	
	public PercentilePartition(int[] partArr, int lowPercentile, int highPercentile) {
		this.partArr = partArr;
		int lo = 1;
		int hi = 5;
		calcPercentileIndices(lowPercentile, highPercentile);
		this.partitionPercentile(lo, hi);
		System.out.print("\n\n");
		for (int i = lo; i < hi; i++) {
			System.out.print(partArr[i] + ", ");
		}
	}
	private void calcPercentileIndices(int lowPercentile, int highPercentile) { //10 els, 10 percentile -> 1
		lowPercentileIndex = (int) ((lowPercentile/100.0)*partArr.length);
		highPercentileIndex = (int) ((highPercentile/100.0)*partArr.length);
		System.out.println("Percentile indices " + lowPercentileIndex + "," + highPercentileIndex);
	}
	private void partitionPercentile(int targetLo, int targetHi) {
		PartitionResult pr = new PartitionResult(partArr, -1 /*obs*/, 0, partArr.length-1);
		System.out.println("Init pr: " + pr);
		
			
		while(pr.pivotIndex < targetLo || pr.pivotIndex > targetHi) {
			if(pr.pivotIndex < targetLo) {
				pr = partition(pr.arr, pr.pivotIndex+1, pr.endIndex);
			}else if(pr.pivotIndex > targetHi) {
				pr = partition(pr.arr, pr.startIndex, pr.pivotIndex-1);
			}
		}
		System.out.println("L1 done, oldrange:" + pr.startIndex + ":" + pr.endIndex + "\n" + pr);
		//System.exit(1);
		int pivotIndexOnSplit = pr.pivotIndex;
		int endIndexOnSplit = pr.endIndex;

		pr = new PartitionResult(partArr, pr.startIndex, pr.startIndex, pr.pivotIndex-1);
		while(pr.pivotIndex != targetLo) {
			if(pr.pivotIndex < targetLo) {
				pr = partition(pr.arr, pr.pivotIndex, pr.endIndex);
				System.out.println("Lo, pr " + pr);
			}else if(pr.pivotIndex > targetLo) {
				pr = partition(pr.arr, pr.startIndex, pr.pivotIndex);
				System.out.println("Hi, pr " + pr);
			}
		}
		System.out.println("L2 done, pivot (actually lo):" + pr.pivotIndex);
		
		pr = new PartitionResult(partArr, pivotIndexOnSplit, pivotIndexOnSplit, endIndexOnSplit);
		while(pr.pivotIndex != targetHi) {
			if(pr.pivotIndex < targetHi) {
				pr = partition(pr.arr, pr.pivotIndex, pr.endIndex);
			}else if(pr.pivotIndex > targetHi) {
				pr = partition(pr.arr, pr.startIndex, pr.pivotIndex);
			}
		}
		System.out.println("L3 done, pivot (actually hi):" + pr.pivotIndex);
		System.out.println(pr);
		
		
	}
	private PartitionResult partition(int[] arr, int startIndex, int endIndex) { //endIndex inclusive
		System.out.println("range: " + startIndex + ":" + endIndex);
		//pick element
		//do nice calcs later, robin (1,5,10) use wieght
		int pivotIndex = startIndex;
		int pivot = arr[startIndex];
		
		//make empty arr
		int[] interestingRange = new int[endIndex-startIndex+1];
		
		for (int i = startIndex, j=0; i <= endIndex;i++,j++) {
			interestingRange[j] = arr[i];
		}
		
		//fill
		int li = startIndex;
		int ri = endIndex;
		boolean pivotSeen = false;
		for(int i = 0;i < interestingRange.length;i++) {
			if ((!pivotSeen) && interestingRange[i] == pivot) {
				
			} else if (interestingRange[i] < pivot) {
				arr[li++] = interestingRange[i];
			}else{
				arr[ri--] = interestingRange[i];
			}
		}
		
		arr[li] = pivot;
		
		System.out.println("Picked pivot" + pivot);// + ", initial index " + pivotIndex + ", pivot and higher from index " + li);
		//System.out.println("Final arr -> " + Arrays.toString(partitioned));
		
		return new PartitionResult(arr, li, startIndex, endIndex);
	}
	private class PartitionResult {
		int[] arr;
		int pivotIndex;
		int startIndex;
		int endIndex;
		PartitionResult(int[] arr, int pivotIndex, int startIndex, int endIndex){
			this.arr = arr;
			this.pivotIndex = pivotIndex;
			this.startIndex = startIndex;
			this.endIndex = endIndex;
		}
		public String toString() {
			return "@" + Arrays.toString(arr) + "|i: " + pivotIndex + "@";
		}
	}
}
