package assignment3AADS;

import java.util.ArrayList;
import java.util.List;

public class MyDirectedGraph implements A3Graph {
	
	public static void main(String[] argz) {
		MyDirectedGraph dg = new MyDirectedGraph();
		dg.addVertex(0);
		dg.addVertex(1);
		dg.addVertex(2);
		dg.addVertex(3);
		dg.addVertex(4);
		dg.addVertex(5);
		dg.addVertex(6);
		dg.addVertex(7);
		dg.addVertex(8);
		System.out.println(dg.isAcyclic());
		dg.addEdge(0, 1);
		dg.addEdge(0, 2);
		dg.addEdge(1, 3);
		dg.addEdge(1, 4);
		dg.addEdge(2, 5);
		dg.addEdge(2, 6);
		dg.addEdge(3, 7);
		dg.addEdge(3, 8);
		System.out.println(dg.isAcyclic());
		dg.addEdge(8, 0);
		System.out.println(dg.isAcyclic());
		System.out.println(dg.connectedComponents());
		dg = new MyDirectedGraph();
		dg.addVertex(0);
		dg.addVertex(1);
		dg.addVertex(2);
		dg.addVertex(3);
		dg.addVertex(4);
		dg.addEdge(1, 3);
		dg.addEdge(3, 2);
		dg.addEdge(2, 1);
		dg.addEdge(1, 4);
		System.out.println(dg.connectedComponents());
		System.out.println("--------------------");
		dg = new MyDirectedGraph();
		dg.addVertex(0);
		dg.addVertex(1);
		dg.addVertex(2);
		dg.addEdge(0, 1);
		dg.addEdge(0, 2);
		dg.addEdge(1, 2);
		System.out.println("connect: " + dg.isConnected());
		System.out.println("acuclic: " + dg.isAcyclic());
		System.out.println("compont: " + dg.connectedComponents());
	}

	private ArrayList<MyVertex> vertices = new ArrayList<>();
	
	@Override
	public void addVertex(int vertex) {
		// To make easier the implementation, you can assume that vertices will always be added with sequential indexes starting from 0.
		// Why then have the vertex number as an argument?
		if (this.vertices.size() != vertex) System.err.println("Not sequential! Warning");
		
		MyVertex newV = new MyVertex(vertex);
		this.vertices.add(newV);
	}

	@Override
	public void addEdge(int sourceVertex, int targetVertex) {
		MyVertex fromVertex = this.vertices.get(sourceVertex);
		MyVertex toVertex = this.vertices.get(targetVertex);
		fromVertex.connections.add(toVertex);
	}

	@Override
	public boolean isConnected() {
		for(MyVertex v : this.vertices) {
			for(MyVertex v2 : this.vertices) {
				v2.visited = false;
			}
			v.visited = true;
			boolean fromThisNode = dfsRec(v); // true if it can't find the visited node ie. itself
			if (fromThisNode == true) return false; // therefore, not connected
		}
		return true; // if we always found the node, it's strongly connected.
	}

	@Override
	public boolean isAcyclic() {
		for(MyVertex v : this.vertices) {
			for(MyVertex v2 : this.vertices) {
				v2.visited = false;
			}
			v.visited = true;
			boolean fromThisNode = dfsRec(v);
			if (fromThisNode == false) return false;
		}
		return true;
	}
	
	/**
	 * checks if a node does not reach another node that is already visited.
	 * DOES NOT modify the visited status of nodes.
	 */
	public boolean dfsRec(MyVertex inc) {
		for (MyVertex child : inc.connections) {
			if (child.visited == true) {
				return false;
			} else {
				boolean subAcyclic = dfsRec(child);
				if (subAcyclic == false) return false;
			}
		}
		return true;
	}

	@Override
	public List<List<Integer>> connectedComponents() {
		List<List<Integer>> groups = new ArrayList<List<Integer>>();
		for (MyVertex v: this.vertices) {
			if (groups.isEmpty()) {
				// first guy starts the first group.
				List<Integer> newList = new ArrayList<Integer>();
				newList.add(v.id);
				groups.add(newList);
			} else {
				// if he is "strongly connected" to the "first" vertex in any group, he is to the rest of the group
				boolean inAny = false;
				for (List<Integer> group: groups) {
					MyVertex representative = this.vertices.get(group.get(0));
					if (this.ccReachable(v, representative) && this.ccReachable(representative, v)) {
						group.add(v.id);
						inAny = true;
					}
				}
				// if he wasn't, he starts a group of his own
				if (!inAny) {
					List<Integer> newList = new ArrayList<Integer>();
					newList.add(v.id);
					groups.add(newList);
				}
			}
		}
		return groups;
	}
	private boolean ccReachable(MyVertex from, MyVertex to) {
		for(MyVertex v : this.vertices) {
			v.visited = false;
		}
		to.visited = true;
		return !ccRec(from, from);
	}
	public boolean ccRec(MyVertex inc, MyVertex start) {
		for (MyVertex child : inc.connections) {
			if (child.visited == true) {
				return false;
			} else if (!child.equals(start)) {
				boolean subAcyclic = ccRec(child, start);
				if (subAcyclic == false) return false;
			}
		}
		return true;
	}
}
