package assignment3AADS;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

public class MySocialNetwork /* extends MyUndirectedGraph NO THANKS */ implements A3SocialNetwork {

	public static void main(String[] a) {
		/*
		 *	this is the graph included in assignment description. There are duplicate nines, i renamed the lone one to zero. 
		 */
		MySocialNetwork fb = new MySocialNetwork();
		fb.addPersons(15);
		fb.addFriendship(11, 7);
		fb.addFriendship(10, 7);
		fb.addFriendship(10, 8);
		fb.addFriendship(10, 9);
		fb.addFriendship(7, 5);
		fb.addFriendship(8, 5);
		fb.addFriendship(9, 5);
		fb.addFriendship(5, 12);
		fb.addFriendship(5, 0);
		fb.addFriendship(5, 1);
		fb.addFriendship(5, 2);
		fb.addFriendship(5, 4);
		fb.addFriendship(5, 6);
		fb.addFriendship(6, 14);
		fb.addFriendship(1, 3);
		fb.addFriendship(1, 4);
		fb.addFriendship(1, 2);
		fb.addFriendship(2, 3);
		fb.addFriendship(2, 4);
		fb.addFriendship(4, 3);
		fb.addFriendship(3, 6);
		fb.addFriendship(3, 13);
		System.out.println("Number of frinends: " + fb.numberOfPeopleAtFriendshipDistance(5, 2));
		System.out.println("    these ones: " + fb.ddfsFound);
		System.out.println("\nDeepest friend: " + fb.furthestDistanceInFriendshipRelationships(5));
		System.out.println("\nPossible friends: " + fb.possibleFriends(5));
	}
	
	ArrayList<Person> people = new ArrayList<>();
	
	@SuppressWarnings("unused")
	private static class Person {
		int id;
		private static int idcount = 0;
		ArrayList<Person> friends = new ArrayList<>();
		public Person() {
			this.id = Person.idcount++;
		}
		public Person(int id) { // danger zone
			this.id = id;
			Person.idcount++;
		}
		@Override
		public int hashCode() {
			return this.id;
		}
		@Override
		public String toString() {
			return "" + this.id;
		}
	}
	public void addPersons(int amt) {
		for (int i = 0; i < amt; i++) {
			this.people.add(new Person());
		}
	}
	public void addFriendship(int id1, int id2) {
		this.people.get(id1).friends.add(this.people.get(id2));
		this.people.get(id2).friends.add(this.people.get(id1));
	}

	public void addVertex(int vertex) {this.people.add(new Person(vertex));};
	public void addEdge(int sourceVertex,  int targetVertex) {this.addFriendship(sourceVertex, targetVertex);};
	
	
	/*
	 * 
	 * friendship distance
	 * 
	 */
	
    @Override
    public int numberOfPeopleAtFriendshipDistance(int vertexIndex, int distance) {
    	return distanceDFS(this.people.get(vertexIndex), distance);
    }
    
    private ArrayList<Integer> ddfsFound;
    private HashMap<Person, Integer> ddfsDistance;
    // setup before recursion
    private int distanceDFS(Person current, int ddfsTarget) {
    	ddfsDistance = new HashMap<>(); // no-one is visited
    	ddfsFound = new ArrayList<>(); // no-one is found
    	int ddfsFoundAmount = 0;
    	distanceDFSrec(current, null, 0); // kick off recursive part
    	Iterator<Person> nodes = ddfsDistance.keySet().iterator();
    	while(nodes.hasNext()) {
    		Person p = nodes.next();
    		int depth = ddfsDistance.get(p);
        	// depth checks
        	if (depth == ddfsTarget) {
        		ddfsFound.add(p.id);
        		ddfsFoundAmount += 1;
        	}
    	}
    	return ddfsFoundAmount;
    }
    private void distanceDFSrec(Person current, Person previous, int depth) {
    	// visited
    	ddfsDistance.put(current, depth); // best depth yet
    	
    	// recurse
    	for (Person p: current.friends) {
    		if (previous == null) {
    			distanceDFSrec(p, current, depth+1);
    		} else if (previous.id != p.id) {
    			boolean ck = ddfsDistance.containsKey(p);
    			if (!ck || ddfsDistance.get(p) > depth + 1) {
    				distanceDFSrec(p, current, depth+1);
    			}
    		}
    	}
    }
    

	/*
	 * 
	 * furthest distance
	 * 
	 */

    @Override
    public int furthestDistanceInFriendshipRelationships(int vertexIndex) {
	// TODO Auto-generated method stub
    	return furthestDFS(this.people.get(vertexIndex));
    }
    
    // setup before recursion
    private int furthestDFS(Person current) {
    	ddfsDistance = new HashMap<>(); // no-one is visited
    	ddfsFound = new ArrayList<>(); // no-one is found
    	distanceDFSrec(current, null, 0); // kick off recursive part
    	Iterator<Person> nodes = ddfsDistance.keySet().iterator();
    	int deepest = -1;
    	int deepestId = -1;
    	while(nodes.hasNext()) {
    		Person p = nodes.next();
    		int depth = ddfsDistance.get(p);
        	// depth checks
        	if (depth >= deepest) {
        		deepest = depth;
        		deepestId = p.id;
        	}
    	}
    	return deepest;
    }

    @Override
    public List<Integer> possibleFriends(int vertexIndex) {
    	// the same method again, the recursive thing that collects the depth.
    	Person mainPerson = this.people.get(vertexIndex);
    	ddfsDistance = new HashMap<>(); 
    	ddfsFound = new ArrayList<>(); 
    	distanceDFSrec(mainPerson, null, 0);
    	
    	// we now have depth data of every person.
    	Iterator<Person> nodes = ddfsDistance.keySet().iterator();
    	
    	// save how many times they are counted here
    	HashMap<Person, Integer> fofs = new HashMap<>(); // friends of friends - people with distance 2 go here.
    	                                                 // integer value = amount of bridging people.
    	while(nodes.hasNext()) {
    		Person p = nodes.next();
    		int depth = ddfsDistance.get(p);
    		
        	if (depth == 1) {
        		// this person is a possible conduit - "bridging person"
        		for (Person fof : p.friends) {
        			if (ddfsDistance.get(fof) == 2) { // we dont want to count people with distance 1
        				int fofCount = 1;
        				if (fofs.containsKey(fof)) {
        					fofCount = fofs.get(fof) + 1;
        				}
        				fofs.put(fof, fofCount);
        			}
        		}
        	}     
    	}
    	
    	// find those with high enough count
    	List<Integer> possibleFriends = new ArrayList<>();
    	Iterator<Person> fofKeys = fofs.keySet().iterator(); // all people two steps removed
    	while(fofKeys.hasNext()) {
    		Person currentFof = fofKeys.next();
    		int currentCount = fofs.get(currentFof); // number of "bridging" friends 
    		if (currentCount >= 3) {
    			possibleFriends.add(currentFof.id);
    		}
    	}
  
    	return possibleFriends;
	
    }

}
