package assignment3AADS;

import java.util.ArrayList;
import java.util.List;

public class MyUndirectedGraph implements A3Graph {
	public static void main(String[] argz) {
		MyUndirectedGraph dg = new MyUndirectedGraph();
		dg.addVertex(0);
		dg.addVertex(1);
		dg.addVertex(2);
		dg.addVertex(3);
		dg.addVertex(4);
		/*dg.addVertex(5);
		dg.addVertex(6);
		dg.addEdge(0, 1);
		dg.addEdge(0, 2);
		dg.addEdge(1, 3);
		dg.addEdge(2, 3);
		dg.addEdge(3, 4);
		dg.addEdge(3, 5);
		dg.addEdge(4, 6);
		dg.addEdge(5, 6);*/
		dg.addEdge(1, 0);
		dg.addEdge(1, 3);
		dg.addEdge(1, 4);
		dg.addEdge(1, 2);
		dg.addEdge(0, 3);
		dg.addEdge(3, 2);
		dg.addEdge(2, 4);
		dg.addEdge(4, 3);
		System.out.println(dg.eulerPath());
	}

	private ArrayList<MyVertex> vertices = new ArrayList<>();
	
    @Override
    public void addVertex(int vertex) {
		MyVertex newV = new MyVertex(vertex);
		this.vertices.add(newV);
    }

    @Override
    public void addEdge(int sourceVertex, int targetVertex) {
		MyVertex fromVertex = this.vertices.get(sourceVertex);
		MyVertex toVertex = this.vertices.get(targetVertex);
		fromVertex.connections.add(toVertex);
		toVertex.connections.add(fromVertex);
    }

    @Override
    public boolean isConnected() {
		for(MyVertex v : this.vertices) {
			v.visited = false;
		}
		dfsRec(this.vertices.get(0), null); // depth first traversal, marking anything we see as visited
		for(MyVertex v : this.vertices) {
			if (v.visited == false) return false; // if something's NOT visited, graph's not connected
		}
		return true; 
    }

    @Override
	public boolean isAcyclic() {
		for(MyVertex v : this.vertices) {
			v.visited = false;
		}
		for(MyVertex v : this.vertices) {
			if (v.visited == false) {
				boolean fromThisNode = dfsRec(v, null);
				if (fromThisNode == false) return false;
			}
		}
		return true;
	}
	public boolean dfsRec(MyVertex inc, MyVertex parent) {
		inc.visited = true;
		for (MyVertex child : inc.connections) {
			if (parent == null || !child.equals(parent)) {
				if (child.visited == true) {
					return false;
				} else {
					boolean subAcyclic = dfsRec(child, inc);
					if (subAcyclic == false) return false;
				}
			}
		}
		return true;
	}

    @Override
    public List<List<Integer>> connectedComponents() {
		List<List<Integer>> groups = new ArrayList<List<Integer>>();
		for (MyVertex v: this.vertices) {
			if (groups.isEmpty()) {
				// first guy starts the first group.
				List<Integer> newList = new ArrayList<Integer>();
				newList.add(v.id);
				groups.add(newList);
			} else {
				// if he is "strongly connected" to the "first" vertex in any group, he is to the rest of the group
				boolean inAny = false;
				for (List<Integer> group: groups) {
					MyVertex representative = this.vertices.get(group.get(0));
					if (this.ccReachable(v, representative)) {
						group.add(v.id);
						inAny = true;
					}
				}
				// if he wasn't, he starts a group of his own
				if (!inAny) {
					List<Integer> newList = new ArrayList<Integer>();
					newList.add(v.id);
					groups.add(newList);
				}
			}
		}
		return groups;
	}
	private boolean ccReachable(MyVertex from, MyVertex to) {
		for(MyVertex v : this.vertices) {
			v.visited = false;
		}
		return !ccRec(to, from, null);
	}
	public boolean ccRec(MyVertex find, MyVertex current, MyVertex parent) {
		current.visited = true;
		for (MyVertex child : current.connections) {
			if ( (parent == null || !child.equals(parent)) && !child.visited) {
				if (child.equals(find)) {
					return false;
				} else {
					boolean subAcyclic = ccRec(find, child, current);
					if (subAcyclic == false) return false;
				}
			}
		}
		return true;
	}

    @Override
    public boolean hasEulerPath() {
    	if (!this.isConnected()) return false; // has to be connected
    	int oddcount = 0;
    	for (MyVertex v: this.vertices) {
    		if (v.connections.size() % 2 != 0) oddcount++;
    	}
    	return oddcount == 2 || oddcount == 0;
    }

    @Override
    public List<Integer> eulerPath() {
    	MyVertex target = null;
    	for (MyVertex v : this.vertices) {
    		v.copyConnections(); // a new array so we dont destroy the "real" graph
    	}                        // real bad coding i know :D
    	
    	// find a vertex with odd edges (we must begin there)
    	int i = 0;
    	MyVertex currentVertex;
    	do {
        	currentVertex = this.vertices.get(i++);
        	System.out.println(currentVertex.id + " - " + (currentVertex.connectionsClone.size() %2));
    	} while(currentVertex.connectionsClone.size() %2 == 0 && i < this.vertices.size()); // 
    	
    	// we begin
		ArrayList<Integer> directions = new ArrayList<>();
		directions.add(currentVertex.id);
		
		// currentVertex is where we stand. each iteration of this loop is we find somewhere to go,
		// and take one step.
		// when there is no outgoing edges, we can't make any more moves, and the path is complete.
    	while (currentVertex.connectionsClone.size() > 0) {
    		target = null;
    		
    		if (currentVertex.connectionsClone.size() == 1) {
        		// is there only one, that's where we must go
    			target = currentVertex.connectionsClone.get(0);
    			target.connectionsClone.remove(currentVertex);
				currentVertex.connectionsClone.remove(target);
    		} else {
    			// otherwise, do some sletuthing
    			// findNonBridge: for (MyVertex possibility: currentVertex.connectionsClone) {
    			// 		---> concurrent modification exception
    			findNonBridge: for (int possId = 0; possId < currentVertex.connectionsClone.size(); possId++) {
    				
    				// count before removing
    				MyVertex possibility = currentVertex.connectionsClone.get(possId);
	    			for(MyVertex v : this.vertices) {
	    				v.visited = false;
	    			}
	    			int initCount = countDFS(possibility, null, 0);
					
	    			// count after removing, emulated by tricking the DFS that we came from the current vertex 
	    			for(MyVertex v : this.vertices) {
	    				v.visited = false;
	    			}
	    			int secondCount = countDFS(possibility, currentVertex, 0); // dont go over the bridge!
	    			
	    			// bridge or no bridge
	    			if (secondCount == initCount) {
		    			possibility.connectionsClone.remove(currentVertex);
						currentVertex.connectionsClone.remove(possibility);
		        		target = possibility;
	    				break findNonBridge; // we're done here
	    			}
	    			// otherwise a bridge, try again.
	    		}
    		}
    		currentVertex = target;
    		directions.add(currentVertex.id);
    	}
    	
    	
		return directions;
    }
    
    private int countDFS(MyVertex current, MyVertex parent, int count) {
		current.visited = true;
		for (MyVertex child : current.connectionsClone) {
			if ( (parent == null || !child.equals(parent)) && !child.visited) {
				count = countDFS(child, current, count) + 1;
			}
		}
		return count;
    }
    
    

}
